# トラブルシューティング

## 電源が安定しているかどうか
電源が不安定だと、ESPモジュールが起動しない、または起動しても
正しく動作しないことがあります。
起動時やWi-Fi接続時、カメラ動作時は、多くの電流を消費するので、
目安として600mA程度の電流が流せる電源回路を使用してください。

## シリアルのTXDとRXDはクロス接続
カメラのTXDをESPモジュールのRXD(本サンプルではGPIO16(27番ピン))に、
カメラのRXDをESPモジュールのTXD(本サンプルではGPIO17(28番ピン))に
接続してください。

## LCDに「Example 20 cam」が表示されたまま動作しない①
Wi-Fiアクセスポイントとの接続に失敗しています。
無線LANアクセスポイントのSSIDとパスワードをプログラム内の
#define SSIDとPASSに設定して下さい。

## LCDに「Example 20 cam」が表示されたまま動作しない②
カメラとの通信に失敗しています。
カメラの電源電圧、シリアル配線などを確認してください。

## ブラウザに「防犯カメラ STATUS」の画面が表示されない
ネットワーク内のDHCPサーバが動作していない、
異なる無線LANアクセスポイントへ接続されている、
異なるIPアドレスが設定されている、
無線LANアクセスポイントやRaspberry Piのファイヤーウォール等で
パケットが破棄されているなどが考えられます。

## ブラウザの互換性・ブラウザのセキュリティ対策
ブラウザのバージョンアップやセキュリティ対策により、表示でき
なくなることがあります。
また、ブラウザのバージョンアップで表示できるようになることも
あります。
例えば、IPアドレスによるアクセスを危険と見なす場合もあれば、
同一LAN内のコンテンツは安全と見なす場合など、ブラウザや、その
バージョン、設定、ブラウザを開発する会社の方針などによって
状況が変化します。
一例として、以下のような複数のブラウザで試してみて下さい。
（IE、Edge、Safari、Chrome、FireFoxなど）

## 動作ログの確認方法（ご参考）
Arduino IDEのウィンドウ右上にある虫眼鏡のアイコンをクリックし、
「シリアルモニタ」を起動し、シリアルモニタの右下のボーレートを
115200bpsに設定すると、動作ログが表示されます。
